from pprint import pprint


data1 = [
    {
        "ID": "A001",
        "LEVEL": 1,
        "部品名": "PARTS01",
        "重量": 34.2,
        "納期": "2023-02-21"
    },
    {
        "ID": "A002",
        "LEVEL": 2,
        "部品名": "PARTS02",
        "重量": 12.3,
        "納期": "2023-02-22"
    },
    {
        "ID": "A003",
        "LEVEL": 2,
        "部品名": "PARTS03",
        "重量": 45.6,
        "納期": "2023-02-23"
    },
    {
        "ID": "A004",
        "LEVEL": 3,
        "部品名": "PARTS04",
        "重量": 78.9,
        "納期": "2023-02-24"
    },
    {
        "ID": "A005",
        "LEVEL": 4,
        "部品名": "PARTS05",
        "重量": 90.1,
        "納期": "2023-02-25"
    },
    {
        "ID": "A006",
        "LEVEL": 4,
        "部品名": "PARTS06",
        "重量": 23.4,
        "納期": "2023-02-26"
    },
    {
        "ID": "A007",
        "LEVEL": 3,
        "部品名": "PARTS07",
        "重量": 56.7,
        "納期": "2023-02-27"
    },
    {
        "ID": "A008",
        "LEVEL": 4,
        "部品名": "PARTS08",
        "重量": 89.0,
        "納期": "2023-02-28"
    },
    {
        "ID": "A009",
        "LEVEL": 2,
        "部品名": "PARTS09",
        "重量": 12.3,
        "納期": "2023-03-01"
    },
    {
        "ID": "A010",
        "LEVEL": 3,
        "部品名": "PARTS10",
        "重量": 45.6,
        "納期": "2023-03-02"
    },
    {
        "ID": "A011",
        "LEVEL": 2,
        "部品名": "PARTS11",
        "重量": 78.9,
        "納期": "2023-03-03"
    },
    {
        "ID": "A012",
        "LEVEL": 3,
        "部品名": "PARTS12",
        "重量": 34.1,
        "納期": "2023-03-04"
    },
    {
        "ID": "A013",
        "LEVEL": 4,
        "部品名": "PARTS13",
        "重量": 23.4,
        "納期": "2023-03-05"
    },
    {
        "ID": "A014",
        "LEVEL": 2,
        "部品名": "PARTS14",
        "重量": 56.7,
        "納期": "2023-03-06"
    }
]


data2 = [
    {
        "ID": "A001",
        "LEVEL": 1,
        "部品名": "PARTS01",
        "重量": 34.2,
        "納期": "2023-02-21"
    },
    {
        "ID": "A002",
        "LEVEL": 2,
        "部品名": "PARTS02",
        "重量": 12.3,
        "納期": "2023-02-24"
    },
    {
        "ID": "A003",
        "LEVEL": 2,
        "部品名": "PARTS03",
        "重量": 45.6,
        "納期": "2023-02-23"
    },
    {
        "ID": "A004",
        "LEVEL": 3,
        "部品名": "PARTS04",
        "重量": 78.1,
        "納期": "2023-02-24"
    },
    {
        "ID": "A005",
        "LEVEL": 4,
        "部品名": "PARTS05",
        "重量": 90.1,
        "納期": "2023-02-25"
    },
    {
        "ID": "A007",
        "LEVEL": 3,
        "部品名": "PARTS07",
        "重量": 56.7,
        "納期": "2023-02-27"
    },
    {
        "ID": "A008",
        "LEVEL": 4,
        "部品名": "PARTS08",
        "重量": 89.0,
        "納期": "2023-02-28"
    },
    {
        "ID": "A009",
        "LEVEL": 2,
        "部品名": "PARTS09",
        "重量": 12.3,
        "納期": "2023-03-01"
    },
    {
        "ID": "A010",
        "LEVEL": 3,
        "部品名": "PARTS10",
        "重量": 45.6,
        "納期": "2023-03-02"
    },
    {
        "ID": "A011",
        "LEVEL": 2,
        "部品名": "PARTS11",
        "重量": 78.9,
        "納期": "2023-03-03"
    },
    {
        "ID": "A012",
        "LEVEL": 3,
        "部品名": "PARTS12",
        "重量": 34.1,
        "納期": "2023-03-04"
    },
    {
        "ID": "A013",
        "LEVEL": 4,
        "部品名": "PARTS13-2",
        "納期": "2023-03-05"
    },
    {
        "ID": "A014",
        "LEVEL": 5,
        "部品名": "PARTS14",
        "重量": 56.6,
        "納期": "2023-03-07",
        "部門": "設計"
    },
    {
        "ID": "A015",
        "LEVEL": 6,
        "部品名": "PARTS15",
        "重量": 56.2,
        "納期": "2023-01-07",
    }
]


def checkChild(data):
    """
    テーブルからnodeごとの子供リストを返す
    """

    dictOut = {}
    for index, row in enumerate(data):
        # print(f'----- {index} -----')
        # print(row)
        dict1 = data[index]
        for cnt in range(index + 1, len(data)):
            # print(cnt)
            dict2 = data[cnt]
            if dict2['LEVEL'] <= dict1['LEVEL']:
                break

            if dict1['LEVEL'] + 1 == dict2['LEVEL']:
                # print(dict2)
                if dict1["ID"] not in dictOut:
                    dictOut[dict1["ID"]] = [dict2["ID"]]
                else:
                    dictOut[dict1["ID"]].append(dict2["ID"])

    return dictOut


def find_dictionary_by_id(data, target_id):
    for dictionary in data:
        if dictionary["ID"] == target_id:
            return dictionary
    return None


def diffAttrTable(data_org, data_new):
    """
    data_rewに対して、data_orgとの差分を返す
    """

    dictOut = {}
    for row in data_new:
        new_id = row["ID"]
        dictOrg = find_dictionary_by_id(data_org, new_id)
        if dictOrg is None:
            dictOut[new_id] = {"行追加": row}
        else:
            dictOut[new_id] = diffAttrRow(dictOrg, row)

    for row in data_org:
        org_id = row["ID"]
        dictOrg = find_dictionary_by_id(data_new, org_id)
        if dictOrg is None:
            dictOut[org_id] = {"行削除": row}

    return dictOut


def diffAttrRow(data_org, data_new):
    """  
    二つの辞書の変更、追加、削除をチェックして結果を辞書で返す
    """

    dictDiff = {}
    dictDiff['変更'] = {}
    dictDiff['追加'] = {}
    dictDiff['削除'] = {}

    for key in data_org:
        val = data_org[key]
        if key not in data_new:
            dictDiff['削除'][key] = val

    for key in data_new:
        val = data_new[key]
        if key not in data_org:
            dictDiff['追加'][key] = val
        else:
            if val != data_org[key]:
                dictDiff['変更'][key] = {"旧": data_org[key], "新": val}

    return dictDiff


if __name__ == "__main__":

    # data2からID="A002"の辞書があれば、その辞書あればその辞書を返す
    # print('****** data2 *******')
    # ret = checkChild(data2)
    # pprint(ret)

    # data_org = {
    #     "ID": "A010",
    #     "LEVEL": 3,
    #     "部品名": "PARTS10",
    #     "重量": 45.6,
    #     "納期": "2023-03-02"
    # }

    # data_new = {
    #     "ID": "A010",
    #     "LEVEL": 3,
    #     "重量": 45.5,
    #     "納期": "2023-03-01",
    #     "部門": "設計"
    # }

    # ret = diffAttrRow(data_org, data_new)
    # pprint(ret)

    ret = diffAttrTable(data1, data2)
    pprint(ret)

    # print('****** data1 *******')
    # ret = checkChild(data1)
    # pprint(ret)
    # print('****** data2 *******')
    # ret = checkChild(data2)
    # pprint(ret)

    # dict1 = checkChild(data1, data2)
